ome-qtwidgets 5.3.2

Public Member Functions | Private Attributes | List of all members
ome::qtwidgets::gl::v33::Image2D Class Reference

2D (xy) image renderer. More...

`#include <ome/qtwidgets/gl/v33/V33Image2D.h>`

Inheritance diagram for ome::qtwidgets::gl::v33::Image2D:
[legend]
Collaboration diagram for ome::qtwidgets::gl::v33::Image2D:
[legend]

## Public Member Functions
| Image2D (ome::compat::shared_ptr< ome::files::FormatReader > reader, ome::files::dimension_size_type series, QObject *parent=0)
| Create a 2D image. More...
virtual | ~Image2D ()
| Destructor.
void | render (const glm::mat4 &mvp)
| Render the image. More...
Public Member Functions inherited from ome::qtwidgets::gl::Image2D
| Image2D (ome::compat::shared_ptr< ome::files::FormatReader > reader, ome::files::dimension_size_type series, QObject *parent=0)
| Create a 2D image. More...
virtual void | create ()
| Create GL buffers. More...
void | setPlane (ome::files::dimension_size_type plane)
| Set the plane to render. More...
const glm::vec3 & | getMin () const
| Get minimum limit for linear contrast. More...
void | setMin (const glm::vec3 &min)
| Set minimum limit for linear contrast. More...
const glm::vec3 & | getMax () const
| Get maximum limit for linear contrast. More...
void | setMax (const glm::vec3 &max)
| Set maximum limit for linear contrast. More...
unsigned int | texture ()
| Get texture ID. More...
unsigned int | lut ()
| Get LUT ID. More...

## Private Attributes
glsl::v330::GLImageShader2D * | image_shader
| The shader program for image rendering.

## Additional Inherited Members
Public Types inherited from ome::qtwidgets::gl::Image2D
enum | RangePolicy { StorageRange, BPPRange, PlaneRange, ImageRange }
| Range of min/max adjustment for linear contrast. More...
Protected Member Functions inherited from ome::qtwidgets::gl::Image2D
virtual void | setSize (const glm::vec2 &xlim, const glm::vec2 &ylim)
| Set the size of the x and y dimensions. More...
Protected Attributes inherited from ome::qtwidgets::gl::Image2D
QOpenGLVertexArrayObject | vertices
| The vertex array.
QOpenGLBuffer | image_vertices
| The image vertices.
QOpenGLBuffer | image_texcoords
| The image texture coordinates.
QOpenGLBuffer | image_elements
| The image elements.
unsigned int | textureid
| The identifier of the texture owned and used by this object.
unsigned int | lutid
| The identifier of the LUTs owned and used by this object.
glm::vec3 | texmin
| Linear contrast minimum limits.
glm::vec3 | texmax
| Linear contrast maximum limits.
glm::vec3 | texcorr
| Linear contrast correction multipliers.
ome::compat::shared_ptr< ome::files::FormatReader > | reader
| The image reader.
ome::files::dimension_size_type | series
| The image series.
ome::files::dimension_size_type | plane
| The current image plane.

## Detailed Description

2D (xy) image renderer.

Draws the specified image, using a user-selectable plane.

The render is greyscale with a per-channel min/max for linear contrast.

## Constructor & Destructor Documentation

## § Image2D()

ome::qtwidgets::gl::v33::Image2D::Image2D | ( | ome::compat::shared_ptr< ome::files::FormatReader > | reader,
|  | ome::files::dimension_size_type | series,
|  | QObject * | parent = `0`
| ) |  |
| explicit

Create a 2D image.

The size and position will be taken from the specified image.

Parameters

  reader | the image reader.
  series | the image series.
  parent | the parent of this object.

## Member Function Documentation

## § render()

void ome::qtwidgets::gl::v33::Image2D::render | ( | const glm::mat4 & | mvp | ) |
| virtual

Render the image.

Parameters

  mvp | the model view projection matrix.

Implements ome::qtwidgets::gl::Image2D.

References ome::qtwidgets::gl::check_gl(), ome::qtwidgets::glsl::v330::GLImageShader2D::disableCoords(), ome::qtwidgets::glsl::v330::GLImageShader2D::disableTexCoords(), ome::qtwidgets::glsl::v330::GLImageShader2D::enableCoords(), ome::qtwidgets::glsl::v330::GLImageShader2D::enableTexCoords(), ome::qtwidgets::gl::Image2D::image_elements, image_shader, ome::qtwidgets::gl::Image2D::image_texcoords, ome::qtwidgets::gl::Image2D::image_vertices, ome::qtwidgets::gl::Image2D::lutid, ome::qtwidgets::glsl::v330::GLImageShader2D::setCoords(), ome::qtwidgets::glsl::v330::GLImageShader2D::setCorrection(), ome::qtwidgets::glsl::v330::GLImageShader2D::setLUT(), ome::qtwidgets::glsl::v330::GLImageShader2D::setMax(), ome::qtwidgets::glsl::v330::GLImageShader2D::setMin(), ome::qtwidgets::glsl::v330::GLImageShader2D::setModelViewProjection(), ome::qtwidgets::glsl::v330::GLImageShader2D::setTexCoords(), ome::qtwidgets::glsl::v330::GLImageShader2D::setTexture(), ome::qtwidgets::gl::Image2D::texcorr, ome::qtwidgets::gl::Image2D::texmax, ome::qtwidgets::gl::Image2D::texmin, ome::qtwidgets::gl::Image2D::textureid, and ome::qtwidgets::gl::Image2D::vertices.

The documentation for this class was generated from the following files:

- ome/qtwidgets/gl/v33/V33Image2D.h
- ome/qtwidgets/gl/v33/V33Image2D.cpp